// NpMsgrConfig.h: interface for the CNpMsgrConfig class.
//
//////////////////////////////////////////////////////////////////////
#pragma once

#pragma warning( disable : 4786 )
#include <string>
using namespace std;

#include "INpMsgr.h"



/**
	@ingroup	NpMsgr
	@brief		INpMsgrConfig  Ͽ ޽  ȯ漳  
	@author		翵
*/
class CNpMsgrConfig : public INpMsgrConfig
{
	string m_strServerConfigData;
public:
	CNpMsgrConfig();
	virtual ~CNpMsgrConfig();

	INpMsgrUser * m_pNpMsgrUser;
	void UpdateServerConfig(char * pServerConfigData, USHORT usServerConfigDataLength);
	ULONG GetServerConfigCacheSerial();

// INpMsgrConfig

	virtual void InitModule(INpMsgrUser * pNpMsgrUser);
	
	virtual bool LoadServerConfigFromCacheFile();
	
	virtual bool GetClientUserConfig(LPCSTR szConfigName, char szValue[], int nMax);
	virtual bool GetServerUserConfig(LPCSTR szConfigName, char szValue[], int nMax);

	virtual bool GetClientConfig(LPCSTR szConfigName, char szValue[], int nMax);
	virtual bool GetServerConfig(LPCSTR szSection, LPCSTR szConfigName, char szValue[], int nMax);
	
	virtual bool GetFilePath(LPCSTR szPathName, char szPath[], int nMax=MAX_PATH);
	virtual bool GetDirectoryPath(LPCSTR szPathName, char szPath[], int nMax=MAX_PATH);
};
